
def read_file(filename):
    f=open(filename)
    domains={}
    f.readline()
    for row in f.readlines():
        data=row.split()
        domain=data[8]
        if not domains.has_key(domain):
            domains[domain]=[]
        domains[domain].append((data[0],int(data[1]),int(data[2])))
    return domains

def compute_average_length(domains):
    length4domain={}
    for (domain,entries) in domains.items():
        avg_length=0.
        for (prot,start,end) in entries:
            avg_length+=end-start+1
        avg_length/=len(entries)
        length4domain[domain]=avg_length
    return length4domain
    
def compute_number_of_proteins(domains):
    prot4domain={}
    for (domain,entries) in domains.items():
        prots={}
        for (prot,start,end) in entries:
            prots[prot]=1
        prot4domain[domain]=len(prots)
    return prot4domain

def print_statistics(length4domain,prot4domain):
    print "domain\t\t\tavg_length\tnum_prots"
    for domain in length4domain.keys():
        print "%s\t\t\t%f\t%d" %(domain,length4domain[domain],prot4domain[domain])

def compute_domain_statistics(filename):
    domains = read_file(filename)
    lengths=compute_average_length(domains)
    prots=compute_number_of_proteins(domains)
    print_statistics(lengths,prots)
    
filename=raw_input("Name of file: ")
compute_domain_statistics(filename)
